package org.lym.pom.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.experimental.Accessors;
import org.shoulder.data.mybatis.template.entity.LogicDeleteEntity;

/**
 * 友情链接
 * 申请、审核
 *
 * @author lym
 */
@Getter
@Setter
@Accessors(chain = true)
@NoArgsConstructor
public class FriendLink
        extends LogicDeleteEntity<Long> {

    /**
     * 类型：合作伙伴、推荐站点、互换友链
     */
    @TableField("type")
    private String type;

    /**
     * 链接
     */
    @TableField("link")
    private String link;

    /**
     * logo_url 图标
     */
    @TableField("logo_url")
    private String logoUrl;

    /**
     * 名称
     */
    @TableField("name")
    private String name;

    /**
     * 展示顺序
     */
    @TableField("display_order")
    private Integer displayOrder;

    /**
     * 描述
     */
    @TableField("description")
    private String description;

    /**
     * 状态：
     * 申请：待审核
     * 通过：正常
     * 驳回：不通过
     */
    @TableField("status")
    private String status;

}