package org.lym.pom.notify.event;

import lombok.AllArgsConstructor;
import lombok.Data;
import org.lym.pom.repository.mongo.Comment;

/**
 * 新增评论事件
 *  通知发帖人有新评论
 *  通知被提及的人有人@你
 *  通知被评论消息作者有新的评论（注册任务）
 *  （更新帖子评论数）
 *  （灰度通知粉丝：您关注的xxx在xxx有动态）
 *  （推荐系统，为评论人调整该类帖子的喜好分、以及同类评论的展示优先级（AI分析评论内容）
 *
 * @author lym
 */
@Data
@AllArgsConstructor
public class CommentAddEvent {

    /**
     * 新增的评论
     */
    private Comment comment;

    /**
     * 暂未使用
     * 父评论，方便更新缓存，判断是否立即更新或者是异步更新（热评模式）
     */
    private Comment parent;

}
