package org.lym.pom.repository;

import org.lym.pom.repository.mongo.Feed;
import org.springframework.data.mongodb.repository.MongoRepository;

import java.util.List;

/**
* Description: DAO. 
*   Deal directly with the database, 
*   if you customize the query, take the index first
* 
* 		Please follow the prefix convention below
*
*   getOne ------------ getXXX
*   getMultiple ------- listXXX
*   count ------------- countXXX
*   getOne ------------ getXXX
*   insert ------------ saveXXX
*   delete ------------ deleteXXX
*   modify ------------ updateXXX
*
 * @author lym
 */
public interface FeedRepository extends MongoRepository<Feed, String> {

    List<Feed> findByUserIdAndRelatedCreator(String userId, String relatedCreator);
}
