package org.lym.pom.repository;

import org.lym.pom.repository.mongo.Post;
import org.springframework.data.mongodb.repository.MongoRepository;

/**
* Description: DAO. 
*   Deal directly with the database, 
*   if you customize the query, take the index first
* 
* 		Please follow the prefix convention below
*
*   getOne ------------ getXXX
*   getMultiple ------- listXXX
*   count ------------- countXXX
*   getOne ------------ getXXX
*   insert ------------ saveXXX
*   delete ------------ deleteXXX
*   modify ------------ updateXXX
*
 * @author lym
 */
public interface PostRepository extends MongoRepository<Post, String> {

}
