package org.lym.pom.repository.mongo;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.index.Indexed;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.data.mongodb.core.mapping.Field;

import java.io.Serializable;

/**
 * 朋友的动态
 * 扩展：
 * <p>
 * 第三方内容集成（将外部内容分享到这，如视频、新闻、音乐）
 * 风控、举报
 *
 * @author lym
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@Document(collection = Feed.COLLECTION_NAME)
public class Feed implements Serializable {

    public static final String COLLECTION_NAME = "feed";

    /**
     * id
     */
    @Id
    private String id;
    /**
     * 时间轴归属人
     */
    @Indexed
    private String userId;
    /**
     * 发布id
     */
    @Field
    private String relatedId;
    /**
     * 发布人id
     */
    @Field
    private String relatedCreator;
    /**
     * 场景
     */
    @Field
    private String scene;
    /**
     * 发布时间
     */
    @Indexed
    private Long createTime;

}
