package org.lym.pom.service;

import org.lym.pom.repository.mongo.Feed;

import java.util.List;

/**
 * 用户分享、状态、时刻记录 - 信息流，服务
 *
 * @author lym
 */
public interface FeedService {

    /**
     * 查发布流
     * @param userId           用户视角
     * @param relatedCreator  null 代表 userId 的可见朋友圈；与userId相同，则是查自己的；不同则是查他人的
     * @return 数据流
     */
    List<Feed> queryByUserId(String userId, String relatedCreator);

    /**
     * 发布后、添加好友后使用
     * @param postFeedList 信息流
     */
    void addFeedList(List<Feed> postFeedList);
}
