package org.lym.pom.util.github.dto;

import lombok.Data;

import java.util.List;

@Data
public class GithubCommitDetail extends GithubCommitInfo {

    String node_id;
    UserInfo author;
    UserInfo committer;
    CommitTree tree;
    String message;
    // 只有 sha、url、html_url
    List<GithubCommitInfo> parents;
    Verification verification;

    @Data
    public static class UserInfo {
        String name;
        String email;
        String date;
    }

    @Data
    public static class CommitTree {
        String sha;
        String url;
    }

    @Data
    public static class Verification {
        boolean verified;
        String reason;
        Object signature;
        Object payload;
    }
}